local addonName = ...
local SimpleActionSets = _G[addonName]
local L = LibStub( "AceLocale-3.0" ):GetLocale(addonName)

local SAS_Temp
local barLength = 12
local maxBar = 9
local enumForceClear, enumForceNoChange = 0, 1
local enumName, enumTexture, enumRank, enumID, enumMacroID, enumSpellID = 1, 2, 3, 4, 5, 6
local Mounts = { -- [mount index] = spellID
		[6] = 458, -- Brown Horse
		[7] = 459, -- Gray Wolf
		[8] = 468, -- White Stallion
		[9] = 470, -- Black Stallion
		[11] = 472, -- Pinto
		[12] = 578, -- Black Wolf
		[13] = 579, -- Red Wolf
		[14] = 580, -- Timber Wolf
		[15] = 581, -- Winter Wolf
		[17] = 5784, -- Felsteed
		[18] = 6648, -- Chestnut Mare
		[19] = 6653, -- Dire Wolf
		[20] = 6654, -- Brown Wolf
		[21] = 6777, -- Gray Ram
		[22] = 6896, -- Black Ram
		[24] = 6898, -- White Ram
		[25] = 6899, -- Brown Ram
		[26] = 8394, -- Striped Frostsaber
		[27] = 8395, -- Emerald Raptor
		[28] = 8980, -- Skeletal Horse
		[31] = 10789, -- Spotted Frostsaber
		[34] = 10793, -- Striped Nightsaber
		[35] = 10795, -- Ivory Raptor
		[36] = 10796, -- Turquoise Raptor
		[38] = 10799, -- Violet Raptor
		[39] = 10873, -- Red Mechanostrider
		[40] = 10969, -- Blue Mechanostrider
		[41] = 13819, -- Warhorse
		[42] = 15779, -- White Mechanostrider Mod B
		[43] = 15780, -- Green Mechanostrider
		[45] = 16055, -- Black Nightsaber
		[46] = 16056, -- Ancient Frostsaber
		[50] = 16080, -- Red Wolf
		[51] = 16081, -- Arctic Wolf
		[52] = 16082, -- Palomino
		[53] = 16083, -- White Stallion
		[54] = 16084, -- Mottled Red Raptor
		[55] = 17229, -- Winterspring Frostsaber
		[56] = 17450, -- Ivory Raptor
		[57] = 17453, -- Green Mechanostrider
		[58] = 17454, -- Unpainted Mechanostrider
		[62] = 17459, -- Icy Blue Mechanostrider Mod A
		[63] = 17460, -- Frost Ram
		[64] = 17461, -- Black Ram
		[65] = 17462, -- Red Skeletal Horse
		[66] = 17463, -- Blue Skeletal Horse
		[67] = 17464, -- Brown Skeletal Horse
		[68] = 17465, -- Green Skeletal Warhorse
		[69] = 17481, -- Rivendare's Deathcharger
		[70] = 18363, -- Riding Kodo
		[71] = 18989, -- Gray Kodo
		[72] = 18990, -- Brown Kodo
		[73] = 18991, -- Green Kodo
		[74] = 18992, -- Teal Kodo
		[75] = 22717, -- Black War Steed
		[76] = 22718, -- Black War Kodo
		[77] = 22719, -- Black Battlestrider
		[78] = 22720, -- Black War Ram
		[79] = 22721, -- Black War Raptor
		[80] = 22722, -- Red Skeletal Warhorse
		[81] = 22723, -- Black War Tiger
		[82] = 22724, -- Black War Wolf
		[83] = 23161, -- Dreadsteed
		[84] = 23214, -- Charger
		[85] = 23219, -- Swift Mistsaber
		[87] = 23221, -- Swift Frostsaber
		[88] = 23222, -- Swift Yellow Mechanostrider
		[89] = 23223, -- Swift White Mechanostrider
		[90] = 23225, -- Swift Green Mechanostrider
		[91] = 23227, -- Swift Palomino
		[92] = 23228, -- Swift White Steed
		[93] = 23229, -- Swift Brown Steed
		[94] = 23238, -- Swift Brown Ram
		[95] = 23239, -- Swift Gray Ram
		[96] = 23240, -- Swift White Ram
		[97] = 23241, -- Swift Blue Raptor
		[98] = 23242, -- Swift Olive Raptor
		[99] = 23243, -- Swift Orange Raptor
		[100] = 23246, -- Purple Skeletal Warhorse
		[101] = 23247, -- Great White Kodo
		[102] = 23248, -- Great Gray Kodo
		[103] = 23249, -- Great Brown Kodo
		[104] = 23250, -- Swift Brown Wolf
		[105] = 23251, -- Swift Timber Wolf
		[106] = 23252, -- Swift Gray Wolf
		[107] = 23338, -- Swift Stormsaber
		[108] = 23509, -- Frostwolf Howler
		[109] = 23510, -- Stormpike Battle Charger
		[110] = 24242, -- Swift Razzashi Raptor
		[111] = 24252, -- Swift Zulian Tiger
		[116] = 25863, -- Black Qiraji Battle Tank
		[117] = 25953, -- Blue Qiraji Battle Tank
		[118] = 26054, -- Red Qiraji Battle Tank
		[119] = 26055, -- Yellow Qiraji Battle Tank
		[120] = 26056, -- Green Qiraji Battle Tank
		[121] = 26655, -- Black Qiraji Battle Tank
		[122] = 26656, -- Black Qiraji Battle Tank
		[123] = 28828, -- Nether Drake
		[125] = 30174, -- Riding Turtle
		[129] = 32235, -- Golden Gryphon
		[130] = 32239, -- Ebon Gryphon
		[131] = 32240, -- Snowy Gryphon
		[132] = 32242, -- Swift Blue Gryphon
		[133] = 32243, -- Tawny Wind Rider
		[134] = 32244, -- Blue Wind Rider
		[135] = 32245, -- Green Wind Rider
		[136] = 32246, -- Swift Red Wind Rider
		[137] = 32289, -- Swift Red Gryphon
		[138] = 32290, -- Swift Green Gryphon
		[139] = 32292, -- Swift Purple Gryphon
		[140] = 32295, -- Swift Green Wind Rider
		[141] = 32296, -- Swift Yellow Wind Rider
		[142] = 32297, -- Swift Purple Wind Rider
		[145] = 33630, -- Blue Mechanostrider
		[146] = 33660, -- Swift Pink Hawkstrider
		[147] = 34406, -- Brown Elekk
		[149] = 34767, -- Thalassian Charger
		[150] = 34769, -- Thalassian Warhorse
		[151] = 34790, -- Dark War Talbuk
		[152] = 34795, -- Red Hawkstrider
		[153] = 34896, -- Cobalt War Talbuk
		[154] = 34897, -- White War Talbuk
		[155] = 34898, -- Silver War Talbuk
		[156] = 34899, -- Tan War Talbuk
		[157] = 35018, -- Purple Hawkstrider
		[158] = 35020, -- Blue Hawkstrider
		[159] = 35022, -- Black Hawkstrider
		[160] = 35025, -- Swift Green Hawkstrider
		[161] = 35027, -- Swift Purple Hawkstrider
		[162] = 35028, -- Swift Warstrider
		[163] = 35710, -- Gray Elekk
		[164] = 35711, -- Purple Elekk
		[165] = 35712, -- Great Green Elekk
		[166] = 35713, -- Great Blue Elekk
		[167] = 35714, -- Great Purple Elekk
		[168] = 36702, -- Fiery Warhorse
		[169] = 37015, -- Swift Nether Drake
		[170] = 39315, -- Cobalt Riding Talbuk
		[171] = 39316, -- Dark Riding Talbuk
		[172] = 39317, -- Silver Riding Talbuk
		[173] = 39318, -- Tan Riding Talbuk
		[174] = 39319, -- White Riding Talbuk
		[176] = 39798, -- Green Riding Nether Ray
		[177] = 39800, -- Red Riding Nether Ray
		[178] = 39801, -- Purple Riding Nether Ray
		[179] = 39802, -- Silver Riding Nether Ray
		[180] = 39803, -- Blue Riding Nether Ray
		[183] = 40192, -- Ashes of Al'ar
		[185] = 41252, -- Raven Lord
		[186] = 41513, -- Onyx Netherwing Drake
		[187] = 41514, -- Azure Netherwing Drake
		[188] = 41515, -- Cobalt Netherwing Drake
		[189] = 41516, -- Purple Netherwing Drake
		[190] = 41517, -- Veridian Netherwing Drake
		[191] = 41518, -- Violet Netherwing Drake
		[196] = 42776, -- Spectral Tiger
		[197] = 42777, -- Swift Spectral Tiger
		[199] = 43688, -- Amani War Bear
		[201] = 43899, -- Brewfest Ram
		[202] = 43900, -- Swift Brewfest Ram
		[203] = 43927, -- Cenarion War Hippogryph
		[204] = 44151, -- Turbo-Charged Flying Machine
		[205] = 44153, -- Flying Machine
		[206] = 44317, -- Merciless Nether Drake
		[207] = 44744, -- Merciless Nether Drake
		[211] = 46197, -- X-51 Nether-Rocket
		[212] = 46199, -- X-51 Nether-Rocket X-TREME
		[213] = 46628, -- Swift White Hawkstrider
		[219] = 48025, -- Headless Horseman's Mount
		[220] = 48027, -- Black War Elekk
		[221] = 48778, -- Acherus Deathcharger
		[222] = 48954, -- Swift Zhevra
		[223] = 49193, -- Vengeful Nether Drake
		[224] = 49322, -- Swift Zhevra
		[225] = 49378, -- Brewfest Riding Kodo
		[226] = 49379, -- Great Brewfest Kodo
		[230] = 51412, -- Big Battle Bear
		[236] = 54729, -- Winged Steed of the Ebon Blade
		[237] = 54753, -- White Polar Bear
		[238] = 55164, -- Swift Spectral Gryphon
		[240] = 55531, -- Mechano-Hog
		[241] = 58615, -- Brutal Nether Drake
		[242] = 58819, -- Swift Brown Steed
		[243] = 58983, -- Big Blizzard Bear
		[246] = 59567, -- Azure Drake
		[247] = 59568, -- Blue Drake
		[248] = 59569, -- Bronze Drake
		[249] = 59570, -- Red Drake
		[250] = 59571, -- Twilight Drake
		[251] = 59572, -- Black Polar Bear
		[253] = 59650, -- Black Drake
		[254] = 59785, -- Black War Mammoth
		[255] = 59788, -- Black War Mammoth
		[256] = 59791, -- Wooly Mammoth
		[257] = 59793, -- Wooly Mammoth
		[258] = 59797, -- Ice Mammoth
		[259] = 59799, -- Ice Mammoth
		[262] = 59961, -- Red Proto-Drake
		[263] = 59976, -- Black Proto-Drake
		[264] = 59996, -- Blue Proto-Drake
		[265] = 60002, -- Time-Lost Proto-Drake
		[266] = 60021, -- Plagued Proto-Drake
		[267] = 60024, -- Violet Proto-Drake
		[268] = 60025, -- Albino Drake
		[269] = 60114, -- Armored Brown Bear
		[270] = 60116, -- Armored Brown Bear
		[271] = 60118, -- Black War Bear
		[272] = 60119, -- Black War Bear
		[273] = 60136, -- Grand Caravan Mammoth
		[274] = 60140, -- Grand Caravan Mammoth
		[275] = 60424, -- Mekgineer's Chopper
		[276] = 61229, -- Armored Snowy Gryphon
		[277] = 61230, -- Armored Blue Wind Rider
		[278] = 61294, -- Green Proto-Drake
		[279] = 61309, -- Magnificent Flying Carpet
		[280] = 61425, -- Traveler's Tundra Mammoth
		[284] = 61447, -- Traveler's Tundra Mammoth
		[285] = 61451, -- Flying Carpet
		[286] = 61465, -- Grand Black War Mammoth
		[287] = 61467, -- Grand Black War Mammoth
		[288] = 61469, -- Grand Ice Mammoth
		[289] = 61470, -- Grand Ice Mammoth
		[291] = 61996, -- Blue Dragonhawk
		[292] = 61997, -- Red Dragonhawk
		[293] = 62048, -- Black Dragonhawk Mount
		[294] = 63232, -- Stormwind Steed
		[295] = 63635, -- Darkspear Raptor
		[296] = 63636, -- Ironforge Ram
		[297] = 63637, -- Darnassian Nightsaber
		[298] = 63638, -- Gnomeregan Mechanostrider
		[299] = 63639, -- Exodar Elekk
		[300] = 63640, -- Orgrimmar Wolf
		[301] = 63641, -- Thunder Bluff Kodo
		[302] = 63642, -- Silvermoon Hawkstrider
		[303] = 63643, -- Forsaken Warhorse
		[304] = 63796, -- Mimiron's Head
		[305] = 63844, -- Argent Hippogryph
		[306] = 63956, -- Ironbound Proto-Drake
		[307] = 63963, -- Rusted Proto-Drake
		[308] = 64656, -- Blue Skeletal Warhorse
		[309] = 64657, -- White Kodo
		[310] = 64658, -- Black Wolf
		[311] = 64659, -- Venomhide Ravasaur
		[312] = 64731, -- Sea Turtle
		[313] = 64927, -- Deadly Gladiator's Frost Wyrm
		[314] = 64977, -- Black Skeletal Horse
		[317] = 65439, -- Furious Gladiator's Frost Wyrm
		[318] = 65637, -- Great Red Elekk
		[319] = 65638, -- Swift Moonsaber
		[320] = 65639, -- Swift Red Hawkstrider
		[321] = 65640, -- Swift Gray Steed
		[322] = 65641, -- Great Golden Kodo
		[323] = 65642, -- Turbostrider
		[324] = 65643, -- Swift Violet Ram
		[325] = 65644, -- Swift Purple Raptor
		[326] = 65645, -- White Skeletal Warhorse
		[327] = 65646, -- Swift Burgundy Wolf
		[328] = 65917, -- Magic Rooster
		[329] = 66087, -- Silver Covenant Hippogryph
		[330] = 66088, -- Sunreaver Dragonhawk
		[331] = 66090, -- Quel'dorei Steed
		[332] = 66091, -- Sunreaver Hawkstrider
		[333] = 66122, -- Magic Rooster
		[334] = 66123, -- Magic Rooster
		[335] = 66124, -- Magic Rooster
		[336] = 66846, -- Ochre Skeletal Warhorse
		[337] = 66847, -- Striped Dawnsaber
		[338] = 66906, -- Argent Charger
		[339] = 66907, -- Argent Warhorse
		[340] = 67336, -- Relentless Gladiator's Frost Wyrm
		[341] = 67466, -- Argent Warhorse
		[342] = 68056, -- Swift Horde Wolf
		[343] = 68057, -- Swift Alliance Steed
		[344] = 68187, -- Crusader's White Warhorse
		[345] = 68188, -- Crusader's Black Warhorse
		[349] = 69395, -- Onyxian Drake
		[350] = 69820, -- Sunwalker Kodo
		[351] = 69826, -- Great Sunwalker Kodo
		[352] = 71342, -- Big Love Rocket
		[358] = 71810, -- Wrathful Gladiator's Frost Wyrm
		[363] = 72286, -- Invincible
		[364] = 72807, -- Icebound Frostbrood Vanquisher
		[365] = 72808, -- Bloodbathed Frostbrood Vanquisher
		[366] = 73313, -- Crimson Deathcharger
		[367] = 73629, -- Exarch's Elekk
		[368] = 73630, -- Great Exarch's Elekk
		[371] = 74856, -- Blazing Hippogryph
		[372] = 74918, -- Wooly White Rhino
		[373] = 75207, -- Vashj'ir Seahorse
		[375] = 75596, -- Frosty Flying Carpet
		[376] = 75614, -- Celestial Steed
		[382] = 75973, -- X-53 Touring Rocket
		[386] = 84751, -- Fossilized Raptor
		[388] = 87090, -- Goblin Trike
		[389] = 87091, -- Goblin Turbo-Trike
		[391] = 88331, -- Volcanic Stone Drake
		[392] = 88335, -- Drake of the East Wind
		[393] = 88718, -- Phosphorescent Stone Drake
		[394] = 88741, -- Drake of the West Wind
		[395] = 88742, -- Drake of the North Wind
		[396] = 88744, -- Drake of the South Wind
		[397] = 88746, -- Vitreous Stone Drake
		[398] = 88748, -- Brown Riding Camel
		[399] = 88749, -- Tan Riding Camel
		[400] = 88750, -- Grey Riding Camel
		[401] = 88990, -- Dark Phoenix
		[403] = 90621, -- Golden King
		[404] = 92155, -- Ultramarine Qiraji Battle Tank
		[405] = 92231, -- Spectral Steed
		[406] = 92232, -- Spectral Wolf
		[407] = 93326, -- Sandstone Drake
		[408] = 93623, -- Mottled Drake
		[409] = 93644, -- Kor'kron Annihilator
		[410] = 96491, -- Armored Razzashi Raptor
		[411] = 96499, -- Swift Zulian Panther
		[412] = 96503, -- Amani Dragonhawk
		[413] = 97359, -- Flameward Hippogryph
		[415] = 97493, -- Pureblood Fire Hawk
		[417] = 97560, -- Corrupted Fire Hawk
		[418] = 97581, -- Savage Raptor
		[419] = 98204, -- Amani Battle Bear
		[420] = 98718, -- Subdued Seahorse
		[421] = 98727, -- Winged Guardian
		[422] = 100332, -- Vicious War Steed
		[423] = 100333, -- Vicious War Wolf
		[424] = 101282, -- Vicious Gladiator's Twilight Drake
		[425] = 101542, -- Flametalon of Alysrazor
		[426] = 101573, -- Swift Shorestrider
		[428] = 101821, -- Ruthless Gladiator's Twilight Drake
		[429] = 102346, -- Swift Forest Strider
		[430] = 102349, -- Swift Springstrider
		[431] = 102350, -- Swift Lovebird
		[432] = 102488, -- White Riding Camel
		[433] = 102514, -- Corrupted Hippogryph
		[434] = 103081, -- Darkmoon Dancing Bear
		[435] = 103195, -- Mountain Horse
		[436] = 103196, -- Swift Mountain Horse
		[439] = 107203, -- Tyrael's Charger
		[440] = 107516, -- Spectral Gryphon
		[441] = 107517, -- Spectral Wind Rider
		[442] = 107842, -- Blazing Drake
		[443] = 107844, -- Twilight Harbinger
		[444] = 107845, -- Life-Binder's Handmaiden
		[445] = 110039, -- Experiment 12-B
		[446] = 110051, -- Heart of the Aspects
		[447] = 113120, -- Feldrake
		[448] = 113199, -- Jade Cloud Serpent
		[449] = 118089, -- Azure Water Strider
		[450] = 118737, -- Pandaren Kite
		[451] = 120043, -- Jeweled Onyx Panther
		[452] = 120395, -- Green Dragon Turtle
		[453] = 120822, -- Great Red Dragon Turtle
		[455] = 121820, -- Obsidian Nightwing
		[456] = 121836, -- Sapphire Panther
		[457] = 121837, -- Jade Panther
		[458] = 121838, -- Ruby Panther
		[459] = 121839, -- Sunstone Panther
		[460] = 122708, -- Grand Expedition Yak
		[462] = 123182, -- White Riding Yak
		[463] = 123886, -- Amber Scorpion
		[464] = 123992, -- Azure Cloud Serpent
		[465] = 123993, -- Golden Cloud Serpent
		[466] = 124408, -- Thundering Jade Cloud Serpent
		[467] = 124550, -- Cataclysmic Gladiator's Twilight Drake
		[468] = 124659, -- Imperial Quilen
		[469] = 126507, -- Depleted-Kyparium Rocket
		[470] = 126508, -- Geosynchronous World Spinner
		[471] = 127154, -- Onyx Cloud Serpent
		[472] = 127156, -- Crimson Cloud Serpent
		[473] = 127158, -- Heavenly Onyx Cloud Serpent
		[474] = 127161, -- Heavenly Crimson Cloud Serpent
		[475] = 127164, -- Heavenly Golden Cloud Serpent
		[476] = 127165, -- Heavenly Jade Cloud Serpent
		[477] = 127169, -- Heavenly Azure Cloud Serpent
		[478] = 127170, -- Astral Cloud Serpent
		[479] = 127174, -- Azure Riding Crane
		[480] = 127176, -- Golden Riding Crane
		[481] = 127177, -- Regal Riding Crane
		[484] = 127209, -- Black Riding Yak
		[485] = 127213, -- Brown Riding Yak
		[486] = 127216, -- Grey Riding Yak
		[487] = 127220, -- Blonde Riding Yak
		[488] = 127271, -- Crimson Water Strider
		[492] = 127286, -- Black Dragon Turtle
		[493] = 127287, -- Blue Dragon Turtle
		[494] = 127288, -- Brown Dragon Turtle
		[495] = 127289, -- Purple Dragon Turtle
		[496] = 127290, -- Red Dragon Turtle
		[497] = 127293, -- Great Green Dragon Turtle
		[498] = 127295, -- Great Black Dragon Turtle
		[499] = 127302, -- Great Blue Dragon Turtle
		[500] = 127308, -- Great Brown Dragon Turtle
		[501] = 127310, -- Great Purple Dragon Turtle
		[503] = 129552, -- Crimson Pandaren Phoenix
		[504] = 129918, -- Thundering August Cloud Serpent
		[505] = 129932, -- Green Shado-Pan Riding Tiger
		[506] = 129934, -- Blue Shado-Pan Riding Tiger
		[507] = 129935, -- Red Shado-Pan Riding Tiger
		[508] = 130086, -- Brown Riding Goat
		[509] = 130092, -- Red Flying Cloud
		[510] = 130137, -- White Riding Goat
		[511] = 130138, -- Black Riding Goat
		[515] = 130965, -- Son of Galleon
		[516] = 130985, -- Pandaren Kite
		[517] = 132036, -- Thundering Ruby Cloud Serpent
		[518] = 132117, -- Ashen Pandaren Phoenix
		[519] = 132118, -- Emerald Pandaren Phoenix
		[520] = 132119, -- Violet Pandaren Phoenix
		[521] = 133023, -- Jade Pandaren Kite
		[522] = 134359, -- Sky Golem
		[523] = 134573, -- Swift Windsteed
		[526] = 135416, -- Grand Armored Gryphon
		[527] = 135418, -- Grand Armored Wyvern
		[528] = 136163, -- Grand Gryphon
		[529] = 136164, -- Grand Wyvern
		[530] = 136400, -- Armored Skyscreamer
		[531] = 136471, -- Spawn of Horridon
		[532] = 136505, -- Ghastly Charger
		[533] = 138423, -- Cobalt Primordial Direhorn
		[534] = 138424, -- Amber Primordial Direhorn
		[535] = 138425, -- Slate Primordial Direhorn
		[536] = 138426, -- Jade Primordial Direhorn
		[537] = 138640, -- Bone-White Primal Raptor
		[538] = 138641, -- Red Primal Raptor
		[539] = 138642, -- Black Primal Raptor
		[540] = 138643, -- Green Primal Raptor
		[541] = 139407, -- Malevolent Gladiator's Cloud Serpent
		[542] = 139442, -- Thundering Cobalt Cloud Serpent
		[543] = 139448, -- Clutch of Ji-Kun
		[544] = 139595, -- Armored Bloodwing
		[545] = 140249, -- Golden Primal Direhorn
		[546] = 140250, -- Crimson Primal Direhorn
		[547] = 142073, -- Hearthsteed
		[548] = 142266, -- Armored Red Dragonhawk
		[549] = 142478, -- Armored Blue Dragonhawk
		[550] = 142641, -- Brawler's Burly Mushan Beast
		[551] = 142878, -- Enchanted Fey Dragon
		[554] = 146615, -- Vicious Warsaber
		[555] = 146622, -- Vicious Skeletal Warhorse
		[557] = 148392, -- Spawn of Galakras
		[558] = 148396, -- Kor'kron War Wolf
		[559] = 148417, -- Kor'kron Juggernaut
		[560] = 148428, -- Ashhide Mushan Beast
		[561] = 148476, -- Thundering Onyx Cloud Serpent
		[562] = 148618, -- Tyrannical Gladiator's Cloud Serpent
		[563] = 148619, -- Grievous Gladiator's Cloud Serpent
		[564] = 148620, -- Prideful Gladiator's Cloud Serpent
		[565] = 148626, -- Furious Ashhide Mushan
		[566] = 148970, -- Felsteed
		[567] = 148972, -- Dreadsteed
		[568] = 149801, -- Emerald Hippogryph
		[571] = 153489, -- Iron Chimaera
		[593] = 163024, -- Warforged Nightmare
		[594] = 163025, -- Grinning Reaver
		[600] = 155741, -- Dread Raven
		[603] = 169952, -- Creeping Carpet
		[606] = 170347, -- Core Hound
		[607] = 171436, -- Gorerider Gronnling
		[608] = 171616, -- Dark Riding Clefthoof
		[609] = 171617, -- Blue Riding Clefthoof
		[610] = 171618, -- Grey Riding Clefthoof
		[611] = 171619, -- White Riding Clefthoof
		[612] = 171620, -- Red Riding Clefthoof
		[613] = 171621, -- Armored Clefthoof
		[614] = 171622, -- Brown Draenor Elekk
		[615] = 171623, -- Dark Draenor Elekk
		[616] = 171624, -- Grey Draenor Elekk
		[617] = 171625, -- White Draenor Elekk
		[618] = 171626, -- Armored Elekk
		[650] = 171844, -- Tan Dire Wolf
		[651] = 171845, -- Hellscream's Hog
		[652] = 171846, -- Champion's Treadblade
		[657] = 171851, -- Garn Nighthowl
	}
-----------------------
-- Get/Set Functions --
-----------------------

function SimpleActionSets:GetTemp(x, y)
	if ( x and y ) then
		return SAS_Temp[x][y]
	elseif (x) then
		return SAS_Temp[x]
	else
		return SAS_Temp
	end
end

function SimpleActionSets:SetTemp(x, y, value)
	if ( x and y ) then
		SAS_Temp[x][y] = value
	elseif (x) then
		SAS_Temp[x] = value
	else
		SAS_Temp = value
	end
end

function SimpleActionSets:GetMaxBar()
	return maxBar
end

function SimpleActionSets:GetBarLength()
	return barLength
end

function SimpleActionSets:GetForceClear()
	return enumForceClear
end

function SimpleActionSets:GetForceNoChange()
	return enumForceNoChange
end

function SimpleActionSets:GetEnumName()
	return enumName
end

function SimpleActionSets:GetEnumTexture()
	return enumTexture
end

------------------------
-- Reusable Functions --
------------------------

function SimpleActionSets:TableIsEmpty(table)
	return next(table) == nil
end

function SimpleActionSets:ToBool(value)
	return value == 1
end

function SimpleActionSets:PairsByKeys(t, f)
	local a = {}
	for n in pairs(t) do table.insert(a, n) end
		table.sort(a, f)
		local i = 0
		local iter = function ()
			i = i + 1
			if a[i] == nil then return nil
				else return a[i], t[a[i]]
			end
		end
	return iter
end

function SimpleActionSets:BarEnabled(bar, set)
	if ( not set ) then set = SAS_Temp end
	if ( set and set[bar] ) then
		return not set[bar][0]
	end
end

function SimpleActionSets:BarHasActions(bar, set)
	if ( not set ) then
		set = SAS_Temp
	end
	if ( bar and set[bar] ) then
		for i = 1, barLength do
			if ( set[bar][i] ) then
				return 1
			end
		end
	end
end

function SimpleActionSets:SetTooltip(self, bar, slot)
	-- Sets the Tooltip for the found action
	if ( not bar or not slot ) then return end
	if ( SAS_Temp[bar][slot] ) then
		if ( SAS_Temp[bar][slot] == enumForceClear ) then
			GameTooltip:SetText(L["SAS_TEXT_TOOLTIP_FORCECLEAR"], 1, 1, 1)
			SimpleActionSets:TooltipAddLine(L["SAS_TEXT_TOOLTIP_FORCECLEAR_TIP"])
			GameTooltip:Show()
		elseif ( SAS_Temp[bar][slot] == enumForceNoChange ) then
			GameTooltip:SetText(L["SAS_TEXT_TOOLTIP_FORCENOAPPLY"], 1, 1, 1)
			SimpleActionSets:TooltipAddLine(L["SAS_TEXT_TOOLTIP_FORCENOAPPLY_TIP"])
			GameTooltip:Show()
		else
			local name, texture, rank, id, macro, actionSpellID = SimpleActionSets:ParseActionInfo(SAS_Temp[bar][slot])
			local TooltipReturn
			-- is a macro
			if ( macro ) then
				TooltipReturn = GameTooltip:SetText(name, 1, 1, 1)
				local macroName,macroTexture,macroText = GetMacroInfo(SimpleActionSets:FindMacro(name, texture, macro))
				if ( macroText ) then
					GameTooltip:AddLine(macroText, 0.75, 0.75, 0.75, 1, 1)
					GameTooltip:Show()
				else
					SimpleActionSets:TooltipAddLine(L["SAS_TEXT_TOOLTIP_NOMACRO"])
				end
			-- is a mount
			elseif ( rank == "summonmount" ) then
				local spellID = Mounts[tonumber(id)]
				if ( spellID ) then
					TooltipReturn = GameTooltip:SetMountBySpellID(spellID)
				else
					TooltipReturn = GameTooltip:SetText(name, 1, 1, 1)
					SimpleActionSets:TooltipAddLine(L["SAS_TEXT_TOOLTIP_NOMOUNT"])
				end
			-- is a battle pet
			elseif ( rank == "summonpet" ) then
				local battlePetName = select(8, C_PetJournal.GetPetInfoByPetID(id))
				if ( battlePetName ) then
					TooltipReturn = GameTooltip:SetText(battlePetName, 1, 1, 1)
					GameTooltip:AddLine(SPELL_CAST_TIME_INSTANT, 1, 1, 1)
					local summonTooltip = gsub(BATTLE_PET_TOOLTIP_SUMMON, "%%s", battlePetName)
					GameTooltip:AddLine(summonTooltip)
					GameTooltip:Show()
				else
					SimpleActionSets:TooltipAddLine(L["SAS_TEXT_TOOLTIP_NOBATTLEPET"])
				end
			-- is an equipment set
			elseif ( rank == "equipmentset" ) then
				local equipSetIcon = GetEquipmentSetInfoByName(name)
				if ( equipSetIcon ) then
					TooltipReturn = GameTooltip:SetEquipmentSet(name)
				else
					TooltipReturn = GameTooltip:SetText(name, 1, 1, 1)
					SimpleActionSets:TooltipAddLine(L["SAS_TEXT_TOOLTIP_NOEQUIPMENTSET"])
				end
			-- is a flyout menu
			elseif ( rank == "flyout" ) then
				local _, description, _, isKnown = GetFlyoutInfo(id)
				TooltipReturn = GameTooltip:SetText(name, 1, 1, 1)
				if ( isKnown ) then
					GameTooltip:AddLine(description)
					GameTooltip:Show()
				else
					SimpleActionSets:TooltipAddLine(L["SAS_TEXT_TOOLTIP_NOFLYOUT"])
				end
			-- is an item
			elseif ( id ) then
				local itemID, _, _, _, isToy = SimpleActionSets:FindItem(name)
				if ( itemID ) then
					if ( isToy ) then
						TooltipReturn = GameTooltip:SetToyByItemID(itemID)
					else
						TooltipReturn = GameTooltip:SetItemByID(itemID)
					end
				elseif ( id ~= "?" and select(2, GetItemInfo(id)) ) then
					TooltipReturn = GameTooltip:SetHyperlink(select(2, GetItemInfo(id)))
					SimpleActionSets:TooltipAddLine(L["SAS_TEXT_TOOLTIP_NOTHAVE"])
				else
					TooltipReturn = GameTooltip:SetText(name, 1, 1, 1)
					SimpleActionSets:TooltipAddLine(L["SAS_TEXT_TOOLTIP_NOTVALID"])
				end
			-- is a spell
			else
				local spellNum = SimpleActionSets:FindSpell(name, rank, actionSpellID)
				if ( spellNum ) then
					TooltipReturn = GameTooltip:SetSpellBookItem(spellNum, "spell")
				else
					TooltipReturn = GameTooltip:SetText(name, 1, 1, 1)
					SimpleActionSets:TooltipAddLine(L["SAS_TEXT_TOOLTIP_NOSPELL"])
				end
			end
		end
		if ( TooltipReturn ) then
			self.updateTooltip = TOOLTIP_UPDATE_TIME
		else
			self.updateTooltip = nil
		end
	end
end

function SimpleActionSets:TooltipAddLine(msg)
	-- Adds a coloured line to the tooltip
	GameTooltip:AddLine(msg, 0.012, 0.658, 0.62, 1, 1)
	GameTooltip:Show()
end

function SimpleActionSets:CalcSlotAndBar(id)
	-- slot is 1-12, bar is 0-9
	local slot = mod(id - 1, barLength) + 1
	local bar = (id - slot) / barLength
	return slot, bar
end

function SimpleActionSets:GetNumSpellBookItems()
	local t = GetNumSpellTabs()
	local n
	while true do
		local name, _, offset, numSpells = GetSpellTabInfo(t)
		if ( not name ) then
			break
		end
		n = offset + numSpells
		t = t + 1
	end
	return n
end

function SimpleActionSets:CopyTable(copyTable)
	-- properly copies a table instead of referencing the same table, thanks Sallust.
	if ( not copyTable ) then return end
	local returnTable = {}
	for k, v in pairs(copyTable) do
		if ( type(v) == "table" ) then
			returnTable[k] = self:CopyTable(v)
		else
			returnTable[k] = v
		end
	end
	return returnTable
end

-------------------------------
-- Action Building Functions --
-------------------------------

function SimpleActionSets:BuildCursorAction()
	self:FakeDrag_Drop(true)
	local curtype, detail, subdetail, spellID = GetCursorInfo()
	if ( not curtype ) then
		return
	elseif ( curtype == "item" ) then
		local name, _, _, _, _, _, _, _, _, texture = GetItemInfo(detail)
		if ( name ) then
			return self:BuildActionInfo(name, texture, nil, detail)
		end
	elseif ( curtype == "spell" ) then
		local name, rank, texture = GetSpellInfo(spellID)
		return self:BuildActionInfo(name, texture, rank, nil, nil, spellID)
	elseif ( curtype == "mount" ) then
		local name, _, texture = GetSpellInfo(Mounts[tonumber(detail)])
		if ( name ) then
			return self:BuildActionInfo(name, texture, "summonmount", detail)
		end
	elseif ( curtype == "battlepet" ) then
		local name, texture = select(8, C_PetJournal.GetPetInfoByPetID(detail))
		return self:BuildActionInfo(name, texture, "summonpet", detail)
	elseif ( curtype == "equipmentset" ) then
		local icon = GetEquipmentSetInfoByName(detail)
		return self:BuildActionInfo(detail, "Interface\\Icons\\" .. icon, curtype)
	elseif ( curtype == "flyout" ) then
		local name = GetFlyoutInfo(detail)
		return self:BuildActionInfo(name, subdetail, curtype, detail)
	elseif ( curtype == "macro" ) then
		local name, texture = GetMacroInfo(detail)
		if ( name ) then
			return self:BuildActionInfo(name, texture, nil, nil, detail)
		end
	end
end

function SimpleActionSets:BuildActionInfo(...)
	if ( select("#", ...) == 0 ) then return end

	-- ... = name, texture, rank, id, macroID, spellID
	local temp, string, i = ""
	for i = 1, select("#",...) do
		local val = select(i,...)
		if ( val ) then
			string = (string or "") .. temp .. (val or "") .. ""
			temp = ""
		else
			temp = temp .. ""
		end
	end
	return string
end

function SimpleActionSets:IncActionInfo(action, val, part)
	-- Used to update a single element of an action
	if ( not val ) then return end

	local a = {self:ParseActionInfo(action)}
	a[part] = val

	return self:BuildActionInfo(a[enumName], a[enumTexture], a[enumRank], a[enumID], a[enumMacroID], a[enumSpellID])
end

function SimpleActionSets:ParseActionInfo(action, ...)
	-- Returns action[1] to action[6] if ... is empty, if it contains numbers it
	-- returns those parts in order, eg (action, 4, 2) returns action[4], action[2]
	if ( not action ) then return end
	if type(action) ~= "string" then return action end
	local a = { strsplit("", action) }
	for k, v in pairs(a) do
		if v == "" then
			a[k] = nil
		end
	end
	if ( select("#", ...) > 0 ) then
		local b = {}
		for i = 1, select("#", ...) do
			tinsert(b, a[select(i, ...)])
		end
		return unpack(b)
	else
		return a[enumName], a[enumTexture], a[enumRank], a[enumID], tonumber(a[enumMacroID]), tonumber(a[enumSpellID])
	end
end

function SimpleActionSets:GetActionInfo(slot)
	if ( not HasAction(slot) ) then return end

	local actionType, typeID = GetActionInfo(slot)

	if ( actionType == "spell" ) then
		local spellID
		-- Morphed spells aren't 'known', but their base spell is
		if ( IsSpellKnown(typeID) ) then
			-- Unmorphed Spell
			spellID = typeID
		else
			-- Morphed Spell
			-- Picking up the action off the action bar then using GetCursorInfo returns the base spell ID.
			PickupAction(slot)
			spellID = select(4, GetCursorInfo())
			self:Debug("Morphed Spell: " .. GetSpellInfo(typeID) .. " (" .. typeID .. ") base: " .. GetSpellInfo(spellID) .. " (" .. spellID .. ")")
			PlaceAction(slot)
		end
		local name, rank, texture = GetSpellInfo(spellID)
		return name, texture, rank, nil, nil, spellID
	elseif ( actionType == "item" ) then
		local texture = GetActionTexture(slot)
		return (GetItemInfo(typeID)), texture, nil, typeID
	elseif ( actionType == "macro" ) then
		local name, texture = GetMacroInfo(typeID)
		if ( not texture ) then
			texture = GetActionTexture(slot)
		end
		return name, texture, nil, nil, typeID
	elseif ( actionType == "summonmount" ) then
		local name, _, texture = GetSpellInfo(Mounts[tonumber(typeID)])
		return name, texture, actionType, typeID
	elseif ( actionType == "summonpet") then
		-- typeID = petID
		local name, texture = select(8, C_PetJournal.GetPetInfoByPetID(typeID))
		return name, texture, actionType, typeID
	elseif ( actionType == "equipmentset" ) then
		local icon = GetEquipmentSetInfoByName(typeID)
		return typeID, "Interface\\Icons\\" .. icon, actionType
	elseif ( actionType == "flyout" ) then
		-- GetCursorInfo seems to be only way of finding a flyout's texture
		self:PickupFlyout(typeID)
		local texture = select(3, GetCursorInfo())
		ClearCursor()
		local name = GetFlyoutInfo(typeID)
		return name, texture, actionType, typeID
	end
end

function SimpleActionSets:IterateActions()
	-- Iterate over all current actions
	local actionlist = {}
	for i = 0, maxBar do
		actionlist[i] = {}
		for j = 1, barLength do
			actionlist[i][j] = self:BuildActionInfo(self:GetActionInfo(j + (i * barLength)))
		end
	end

	return actionlist
end

--------------------------
-- Action Set Functions --
--------------------------

function SimpleActionSets:SwapSet(set, player, restoringBackup)
	if ( not player ) then
		player = self:GetPlrName()
		self:Debug("self:SwapSet - No player name specified, using " .. player)
	end

	local actions
	if ( set ) then
		self:Debug("self:SwapSet - about to do copy table on self.db.profiles[" .. player .. "].sets[" .. set .. "]")
		actions = self:CopyTable(self.db.profiles[player].sets[set])
	elseif ( SASMain:IsVisible() ) then
		self:Debug("self:SwapSet - about to do copy table on SAS_Temp")
		actions = self:CopyTable(SAS_Temp)
	else
		return
	end

	if ( not actions ) then
		self:Debug("|wNo actions to change to.")
		return
	end

	if ( not self:GetCombatStatus() ) then
		self:DoSwap(actions, set, player, restoringBackup)
	end
end

function SimpleActionSets:DoSwap(actions, set, player, restoringBackup)
	-- Swaps a saved set to the player's real action bars.
	self:SetSwappingSet(true)
	if ( not player or player == self:GetPlrName() ) then
		self:SetCurrentSet(set)
	end
	ClearCursor()
	for i = 0, maxBar do
		if ( self:BarEnabled(i, actions) and (self:BarHasActions(i, actions) or self.db.profile.emptyBars or restoringBackup) ) then
			for j = 1, barLength do
				local slot = j + i * barLength
				local msg = "Action " .. slot
				if ( actions[i][j] ) then
					if ( actions[i][j] == enumForceClear ) then
						msg = msg .. " forced cleared."
						self:ClearSlot(slot, true)
					elseif ( actions[i][j] == enumForceNoChange ) then
						msg = msg .. " forced no change."
					else
						local ename, _, erank, eid, emacro, eActionSpellID = self:GetActionInfo(slot)
						local name, texture, rank, id, macro, actionSpellID = self:ParseActionInfo(actions[i][j])
						if ( (name == ename and ((rank == erank) or (macro and emacro) or (id and eid))) or (eActionSpellID and eActionSpellID == actionSpellID)) then
							msg = msg .. " is the same as the one trying to be swapped."
						else
							if ( macro ) then
								msg = msg .. " is a macro."
								local macroID = self:FindMacro(name, texture, macro)
								if ( macroID ) then
									PickupMacro(macroID)
									PlaceAction(slot)
								else
									msg = msg .. " |wCouldn't find macro."
									self:ClearSlot(slot)
								end
							elseif ( rank == "summonmount" ) then
								msg = msg .. " is a mount."
								local journalIndex = self:FindMount(id)
								if ( journalIndex ) then
									C_MountJournal.Pickup(journalIndex)
									PlaceAction(slot)
								else
									msg = msg .. " |wCouldn't find mount."
									self:ClearSlot(slot)
								end
							elseif ( rank == "summonpet" ) then
								msg = msg .. " is a battle pet."
								local battlePetInfo = C_PetJournal.GetPetInfoByPetID(id)
								if ( battlePetInfo ) then
									C_PetJournal.PickupPet(id)
									PlaceAction(slot)
								else
									msg = msg .. " |wCouldn't find battlepet."
									self:ClearSlot(slot)
								end
							elseif ( rank == "equipmentset" ) then
								msg = msg .. " is an equipment set."
								local equipSetIcon = GetEquipmentSetInfoByName(name)
								if ( equipSetIcon ) then
									PickupEquipmentSetByName(name)
									PlaceAction(slot)
								else
									msg = msg .. " |wCouldn't find equipment set."
									self:ClearSlot(slot)
								end
							elseif ( rank == "flyout") then
								msg = msg .. " is a flyout menu."
								local isKnown = select(4, GetFlyoutInfo(id))
								if ( isKnown ) then
									self:PickupFlyout(id)
									PlaceAction(slot)
								else
									msg = msg .. " |wCouldn't find flyout menu."
									self:ClearSlot(slot)
								end
							elseif ( id ) then
								msg = msg .. " is an item."
								if ( not self:PlaceItem(slot, id, name, set) ) then
									msg = msg .. " |wCouldn't find item."
								end
							elseif ( name ) then
								msg = msg .. " is a spell."
								local spellNum = self:FindSpell(name, rank, actionSpellID)
								if ( spellNum ) then
									PickupSpellBookItem(spellNum, "spell")
									PlaceAction(slot)
								else
									msg = msg .. " |wCoulnd't find spell."
									self:ClearSlot(slot)
								end
							else
								msg = msg .. " has no name, rank, id, macro?"
							end
						end
						ClearCursor()
					end
				self:Debug(msg)
				elseif ( (not self.db.profile.noEmptyButtons) or restoringBackup ) then
					self:ClearSlot(slot)
				end
			end
		elseif ( not self:BarEnabled(i, actions) ) then
			self:Debug("Bar " .. (i + 1) .. " not enabled, skipping")
		else
			self:Debug("Bar " .. (i + 1) .. " has no actions, skipping")
		end
	end
	ClearCursor()
	self:SetSwappingSet(false)

	-- Clear SAS_ReturnAction which gets set if a morphed spell was in the applied set
	self:ActionPickedUp(nil)
end

function SimpleActionSets:SetExists(set)
	-- Check to see if the set already exists
	if ( self.db.profile.sets[set] ) then
		return true
	end
end

function SimpleActionSets:SaveSet(set)
	set = set or self:GetCurrentSet()
	-- Save a set
	if ( not set ) then return end

	local actions
	if ( SASMain:IsVisible() and SAS_Temp ) then
		actions = self:CopyTable(SAS_Temp)
	else
		actions = self:IterateActions()
	end

	self:Print(L["SAS_TEXT_SAVING"] .. set)
	self.db.profile.sets[set] = self:CopyTable(actions)
	self:Actions_Load(set)
end

function SimpleActionSets:Delete(set)
	-- Delete a set
	self:Print(L["SAS_TEXT_DELETING"] .. set)
	self.db.profile.sets[set] = nil
	if ( self:GetCurrentSet() == set ) then
		self:SetCurrentSet()
	end
	self:Actions_Load()
end

function SimpleActionSets:SetDifferent(set1, set2, strict)
	-- Compare two sets to see if they're different
	if ( not ( set1 and set2 ) ) then
		self:Debug("Problem comparing sets: set1 " .. ((set1 and "exists") or "is missing") .. ", set2 " .. ((set2 and "exists") or "is missing"))
		return true
	end

	for i = 0, maxBar do
		if ( set1[i] ) then
			if ( strict ) then
				if ( set1[i][0] ~= set2[i][0] ) then
					return true
				end
			end
			for j = 1, barLength do
				if ( set1[i][j] ) then
					if ( self:ActionDifferent(set1[i][j], set2[i][j]) ) then
						self:Debug("returning at " .. i .. " " .. j)
						return true
					end
				elseif ( strict and set2[i][j] ) then
					self:Debug("strict returning at " .. i .. " " .. j .. " no set 1 but set 2")
					return true
				end
			end
		elseif ( strict and set2[i] ) then
			self:Debug("strict returning at " .. i .. " no set 1 but set 2")
			return true
		end
	end
end

----------------------
-- Action Functions --
----------------------

function SimpleActionSets:ActionDifferent(a, b)
	if ( not ( a and b ) ) then
		self:Debug("Tried to compare a: " .. strsplit("", a or "missing") .. " and b: " .. strsplit("", b or "missing"))
		return true
	end

	local A = { self:ParseActionInfo(a) }
	local B = { self:ParseActionInfo(b) }
	for k, v in pairs(A) do
		-- Ignores id in case its unknown (items only)
		-- Ignores spellID in case its missing or incorrect, spell name and rank should be enough to identify correct spell
		if ( k ~= enumID and k ~= enumSpellID and (not B[k] or v ~= B[k]) ) then
			self:Debug(k .. " " .. (v or "nil") .. " does not == " .. (B[k] or "nil"))
			return true
		end
	end
end

function SimpleActionSets:GetItemIDFromLink(item)
	if ( not item ) then return end
	-- Find an item's id from it's item link
	return strmatch(item, "item:(%d+):")
end

function SimpleActionSets:GetItemNameFromLink(item)
	-- Find an item's name from it's item link
	if ( item ) then
		for name in gmatch(item, "%[(.+)%]") do
			return name
		end
	end
end

function SimpleActionSets:FindSpell(spell, rank, spellID)
	if ( not spell ) then return end
	local spellBookIndex
	local isFound = false
	local bookSpellID
	local ignoreRank = false

	-- Due to rank being a new addition, will allow it to ignore rank so old saves don't break
	if ( not rank ) then
		ignoreRank = true
	end

	-- Iterate over spells the player has and return location
	for i = 1, self:GetNumSpellBookItems() do
		local spellName, spellRank = GetSpellBookItemName(i, "spell")
		bookSpellID = select(2, GetSpellBookItemInfo(i, "spell"))
		if ( spellName == spell and ( ignoreRank or spellRank == rank ) and bookSpellID == spellID ) then
			-- self:Debug(spellName.."("..( gsub(spellRank, "^$", "no rank") )..", "..bookSpellID..") = "..spell.."("..(rank or "no rank").. ", "..(spellID or "no spellID")..")")
			isFound = true
			spellBookIndex = i
			break
		elseif ( ( ignoreRank or spellRank == rank ) and ( spellName == spell or bookSpellID == spellID ) ) then
			-- Morphed spell (names don't match)
			-- self:Debug("Morph "..spellName.."("..( gsub(spellRank, "^$", "no rank") )..", "..bookSpellID..") = "..spell.."("..(rank or "no rank").. ", "..(spellID or "no spellID")..")")
			isFound = true
			spellBookIndex = i
			break
		end
	end

	if ( isFound and IsSpellKnown(bookSpellID) ) then
		-- Spell is usable within current specialization
		return spellBookIndex
	else
		return nil
	end
end

function SimpleActionSets:FindMacro(name, texture, macro)
	-- Check saved macro id
	local macroName, macroTexture, bestguess
	if ( macro ) then
		macroName, macroTexture = GetMacroInfo(macro)
		if ( macroName == name ) then
			if ( texture and macroTexture == texture ) then
				return macro
			end
			bestguess = macro
		end
	end

	-- If no direct match, iterate over macros and return matching index
	local numAccountMacros, numCharacterMacros = GetNumMacros()
	numCharacterMacros = numCharacterMacros + MAX_ACCOUNT_MACROS
	for i = 1, MAX_ACCOUNT_MACROS + MAX_CHARACTER_MACROS do
		if ( i > numAccountMacros and i < MAX_ACCOUNT_MACROS + 1 ) then
			-- no more global macros, skip to local
			i = MAX_ACCOUNT_MACROS + 1
		end
		if ( i > numCharacterMacros ) then
			-- no more macros
			break
		end
		macroName, macroTexture = GetMacroInfo(i)
		if ( macroName and macroName == name ) then
			if ( texture and macroTexture == texture ) then
				return i
			end
			bestguess = i
		end
	end

	return bestguess
end

function SimpleActionSets:FindMount(mountID)
	for i = 1, C_MountJournal.GetNumMounts() do
		local spellID = select(2, C_MountJournal.GetMountInfo(i))
		if ( spellID == Mounts[tonumber(mountID)] ) then
			return i
		end
	end
end

function SimpleActionSets:RestoreToyBoxFilters(collectedFilter, uncollectedFilter, sourceTypeFilters, savedSearch)
	C_ToyBox.SetFilterCollected(collectedFilter)
	C_ToyBox.SetFilterUncollected(uncollectedFilter)
	C_ToyBox.SetFilterString(savedSearch)

	for i = 1, C_PetJournal.GetNumPetSources() do
		C_ToyBox.SetFilterSourceType(i, sourceTypeFilters[i])
	end
end

function SimpleActionSets:FindItem(item)
	-- Iterate over items the player has and return it's ID and location
	if ( not item ) then return end

	item = tostring(item)

	-- Iterate over bags
	for i = 0, NUM_BAG_SLOTS do
		local bagSlots = GetContainerNumSlots(i)
		if ( bagSlots ) then
			for j = 1, bagSlots do
				local itemLink = GetContainerItemLink(i, j)
				if ( itemLink ) then
					if ( item == self:GetItemIDFromLink(itemLink) or item == self:GetItemNameFromLink(itemLink) ) then
						local itemID = self:GetItemIDFromLink(itemLink)
						return itemID, i, j
					end
				end
			end
		end
	end

	-- Iterate over paper doll
	for i = 0, INVSLOT_LAST_EQUIPPED do
		local itemLink = GetInventoryItemLink("player", i)
		if ( itemLink ) then
			if ( item == self:GetItemIDFromLink(itemLink) or item == self:GetItemNameFromLink(itemLink) ) then
				local itemID = self:GetItemIDFromLink(itemLink)
				return itemID, nil, nil, i
			end
		end
	end

	-- Search ToyBox
	-- Save filters
	local savedSearch = ToyBoxSearchBox:GetText()
	local collectedFilter = C_ToyBox.GetFilterCollected()
	local uncollectedFilter = C_ToyBox.GetFilterUncollected()
	local sourceTypeFilters = {}
	for i = 1, C_PetJournal.GetNumPetSources() do
		sourceTypeFilters[i] = C_ToyBox.IsSourceTypeFiltered(i)
	end

	-- Set up filters for search
	C_ToyBox.SetFilterString("")
	C_ToyBox.ClearAllSourceTypesFiltered()
	C_ToyBox.SetFilterCollected(true)
	C_ToyBox.SetFilterUncollected(false)

	-- Iterate over ToyBox
	for i = 1, C_ToyBox.GetNumTotalDisplayedToys() do
		local itemID = C_ToyBox.GetToyFromIndex(i)

		-- Occurs when ToyBox isn't ready for querying or no toys are known.
		if ( itemID == -1 ) then
			break
		end

		local itemLink = C_ToyBox.GetToyLink(itemID)
		if ( itemLink ) then
			if ( item == self:GetItemIDFromLink(itemLink) or item == self:GetItemNameFromLink(itemLink) ) then
				self:RestoreToyBoxFilters(collectedFilter, uncollectedFilter, sourceTypeFilters, savedSearch)
				return itemID, nil, nil, nil, true -- true to mark item as a toy
			end
		end
	end

	self:RestoreToyBoxFilters(collectedFilter, uncollectedFilter, sourceTypeFilters, savedSearch)
end

function SimpleActionSets:CheckItem(name, actionSlot, set)
	if ( not name ) then return end

	local itemID, bag, bagSlot, inv, isToy = self:FindItem(name)
	if ( not itemID ) then
		itemID = "?"
	elseif ( itemID ~= "?" ) then
		local actionSlot, bar = self:CalcSlotAndBar(actionSlot)
		if ( self.db.profile.sets[set] ) then
			local action = self.db.profile.sets[set][bar][actionSlot]
			local iname, iID = self:ParseActionInfo(action, enumName, enumID)
			if ( iname ) then
				if ( iname == name and iID and iID == "?" ) then
					self:Debug("Updating item in action #" .. actionSlot .. " in set " .. set .. " with itemID.")
					self.db.profile.sets[set][bar][actionSlot] = self:IncActionInfo(action, itemID, enumID)
				else
					self:Debug("|wAttempted to update itemID in action #" .. actionSlot .. " but names are wrong?")
				end
			end
		end
	end

	return itemID, bag, bagSlot, inv, isToy
end

function SimpleActionSets:PickupFlyout(id)
	for i = 1, self:GetNumSpellBookItems() do
		local sbtype, sbid = GetSpellBookItemInfo(i, "spell")
		if ( sbtype == "FLYOUT" and sbid == tonumber(id) ) then
			PickupSpellBookItem(i, "spell")
			break
		end
	end
end

function SimpleActionSets:PlaceItem(slot, id, name, set)
	-- Place an item, if item id is unknown then update it if item is found
	local itemID, bag, bagSlot, inv, isToy

	if ( id == "?" ) then
		itemID, bag, bagSlot, inv, isToy = self:CheckItem(name, slot, set)
	else
		itemID, bag, bagSlot, inv, isToy = self:FindItem(id)
	end

	if ( bag and bagSlot ) then
		PickupContainerItem(bag, bagSlot)
	elseif ( inv ) then
		PickupInventoryItem(inv)
	elseif ( isToy ) then
		C_ToyBox.PickupToyBoxItem(itemID)
	end

	if ( GetCursorInfo() ) then
		PlaceAction(slot)
		return true
	end
end

function SimpleActionSets:ClearSlot(slot, force)
	-- Clear an action slot
	if ( HasAction(slot) and (force or not self.db.profile.noEmptyButtons) ) then
		PickupAction(slot)
		ClearCursor()
	end
end
